# encoding: utf-8
import sys
import math

# donde está la cámara
vc = [0.0, 0.0, 5.0]

# El vector de arriba
va = (0.0, 1.0, 0.0)

# donde ve la cámara
vv = (0.0, 0.0, 0.0)

n = len( sys.argv )
if n != 4:
	print "Args: cx cy cz"
	sys.exit(1)

vc[0] = float( sys.argv[1] )
vc[1] = float( sys.argv[2] )
vc[2] = float( sys.argv[3] )

# La lista de vértices del cubo en 3D:
P = ( (1, 1,1), (1, 1,-1), (-1,  1,-1), (-1, 1,1), 
      (1,-1,1), (1,-1,-1), (-1, -1,-1), (-1,-1,1) )

p2 = [ [0.0, 0.0], [0.0, 0.0], [0.0, 0.0], [0.0, 0.0], 
       [0.0, 0.0], [0.0, 0.0], [0.0, 0.0], [0.0, 0.0] ] 



f = 100.0
u0 = 100.0
v0 =  50.0

# La matriz de proyección:
K = ( (f, 0.0, -u0), (0.0, f, -v0), (0.0, 0.0, -1.0) )

def norma( vv ) :
	a = vv[0]*vv[0] + vv[1]*vv[1] + vv[2]*vv[2]
	a = math.sqrt( a )
	return a

def pcruz( v, u, r ) :
	r[0] = v[1]*u[2] - v[2]*u[1]
	r[1] = v[2]*u[0] - v[0]*u[2]
	r[2] = v[0]*u[1] - v[1]*u[0]

def calcular_R( vc, vv, va, R ) :
	vz = [0.0, 0.0, 0.0]

	vz[0] = vc[0] - vv[0]
	vz[1] = vc[1] - vv[1]
	vz[2] = vc[2] - vv[2]
	n = norma( vz )
	vz[0] /= n
	vz[1] /= n
	vz[2] /= n

	vx = [0.0, 0.0, 0.0]		
	pcruz( va, vz, vx )
	n = norma( vx )
	vx[0] /= n
	vx[1] /= n
	vx[2] /= n

	vy = [0.0, 0.0, 0.0]		
	pcruz( vz, vx, vy )

	R[0][0] = vx[0]
	R[0][1] = vx[1]
	R[0][2] = vx[2]

	R[1][0] = vy[0]
	R[1][1] = vy[1]
	R[1][2] = vy[2]

	R[2][0] = vz[0]
	R[2][1] = vz[1]
	R[2][2] = vz[2]


def proyectar_Puntos( K, R, vc, P, p2 ) :
	# El número de puntos:
	n = len(P)
	vu = [0.0, 0.0, 0.0]
	vv = [0.0, 0.0, 0.0]
	vw = [0.0, 0.0, 0.0]

	i=0
	while i<n :
		# vu = P - vc
		vu[0] = P[i][0] - vc[0]
		vu[1] = P[i][1] - vc[1]
		vu[2] = P[i][2] - vc[2]

		# vv = R vu
		vv[0] = R[0][0]*vu[0] + R[0][1]*vu[1] + R[0][2]*vu[2]
		vv[1] = R[1][0]*vu[0] + R[1][1]*vu[1] + R[1][2]*vu[2]
		vv[2] = R[2][0]*vu[0] + R[2][1]*vu[1] + R[2][2]*vu[2]

		# vw = l K vv
		vw[0] = K[0][0]*vv[0] + K[0][2]*vv[2]
		vw[1] = K[1][1]*vv[1] + K[1][2]*vv[2]
		vw[2] = K[2][2]*vv[2]

		u = vw[0]/vw[2]
		v = vw[1]/vw[2]
		# print u, v

		p2[i][0] = u
		p2[i][1] = v
		i += 1

def dibujar_cubo_2D( P ) :
	# líneas de la tapa de arriba
	i=0;
	while i<4 :
		print P[i][0], P[i][1]
		i += 1
	print P[0][0], P[0][1]
	print

	# líneas de la tapa de abajo
	i=4;
	while i<8 :
		print P[i][0], P[i][1]
		i += 1
	print P[4][0], P[4][1]
	print

	# Las cuatro lineas entre las dos tapas anteriores
	print P[0][0], P[0][1]
	print P[4][0], P[4][1]
	print

	print P[1][0], P[1][1]
	print P[5][0], P[5][1]
	print

	print P[2][0], P[2][1]
	print P[6][0], P[6][1]
	print

	print P[3][0], P[3][1]
	print P[7][0], P[7][1]
	print

R = [[0.0, 0.0, 0.0], [0.0, 0.0, 0.0], [0.0, 0.0, 0.0] ]
calcular_R( vc, vv, va, R )
# print R

proyectar_Puntos( K, R, vc, P, p2 )
	
dibujar_cubo_2D( p2 )
